MODULE Project;

IMPORT
  SYSTEM, W := Windows, C := Controls, F := Forms, S := Stdctrls,
  E := Extctrls, G := Graphics, D := Dialogs;

TYPE
  Char         = W.Char;
  Boolean      = W.Boolean;
  Shortint     = W.Shortint;
  Integer      = W.Integer;
  Longint      = W.Longint;
  Real         = W.Real;
  Longreal     = W.Longreal;
  Pointer      = W.Pointer;
  Set	       = W.Set;
  String       = W.String;
  Name         = W.Name;

  Form = POINTER TO RECORD (F.Form)

    toolbar    : E.Toolbar;
    pagecontrol: E.Pagecontrol;
    rightpanel : C.Control;
    bottompanel: C.Control;
    imagelist  : G.Imagelist;

    opendialog : D.Opendialog;
    savedialog : D.Savedialog;
    printdialog : D.Printdialog;

    PROCEDURE & Create*(Parent: C.Control);
    VAR
      tb       : E.Toolbutton;
      i        : Longint;
      separator: Set;
      enbbtn   : Set;
      btnhints : ARRAY 25 OF Name;
    BEGIN
      Create^(Parent);

      width        := C.screen.width  * 5 DIV 6;
      height       := C.screen.height * 5 DIV 6;
      position     := C.poCenterCenter;
      showhint     := TRUE;

      color        := G.clWhite;

      caption      := "Free Oberon IDE";
      iconname     := "Res\Ide.ico";

      NEW(imagelist,16,16);
      imagelist.LoadFromFile("Res\icon.bmp");

      NEW(toolbar,SELF);
      NEW(toolbar.imagelist,16,16);
      toolbar.imagelist := imagelist;
      (*
      toolbar.leavecolor:= 0F4E6DCH;
      toolbar.entercolor:= 0E2D2C2H;
      toolbar.downcolor := 0ECDBCFH;
      toolbar.colorizecl:= 0AA4040H;
      *)
      separator := {2,5,9,11,14,16,18,22,24};
      enbbtn    := {0,1,16,17,22,23,24};

      btnhints[ 0] := " ";
      btnhints[ 1] := " ";
      btnhints[ 2] := " ";
      btnhints[ 3] := " ...";
      btnhints[ 4] := " ...";
      btnhints[ 5] := "";
      btnhints[ 6] := "";
      btnhints[ 7] := "";
      btnhints[ 8] := "";
      btnhints[ 9] := "";
      btnhints[10] := "";
      btnhints[11] := "";
      btnhints[12] := " ";
      btnhints[13] := " ";
      btnhints[14] := " ";
      btnhints[15] := " ";
      btnhints[16] := "";
      btnhints[17] := "";
      btnhints[18] := "";
      btnhints[19] := "  ";
      btnhints[20] := "";
      btnhints[21] := " ";
      btnhints[22] := "";
      btnhints[23] := " ";
      btnhints[24] := "";

      FOR i:=0 TO LEN(btnhints) - 1 DO
        IF i IN separator THEN tb := toolbar.AddButton("",E.tbsSeparator); END;
        tb := toolbar.AddButton("",E.tbsButton);
        IF i<LEN(btnhints) THEN tb.hint := btnhints[i] END;
        tb.OnClick := TbClick;
        tb.imageindex := i;
        tb.tag := i;
        tb.enabled := FALSE;
        IF i IN enbbtn THEN tb.enabled := TRUE END;
      END;

      NEW(pagecontrol,SELF);
      pagecontrol.align := C.alClient;

      NEW(rightpanel,SELF);
      rightpanel.width := 200;
      rightpanel.align := C.alRight;

      NEW(bottompanel,SELF);
      bottompanel.height := 100;
      bottompanel.align := C.alBottom;

      NEW(opendialog);
      NEW(savedialog);
      NEW(printdialog);

    END Create;

    PROCEDURE Destroy*;
    BEGIN
      imagelist.Destroy;
      pagecontrol:= NIL;
      opendialog := NIL;
      savedialog := NIL;
      printdialog:= NIL;
      Destroy^;
    END Destroy;

    PROCEDURE TbClick*(Sender: C.Object);
    BEGIN
      CASE Sender(E.Toolbutton).tag OF
      | 0 : pagecontrol.NewPage("");
      | 1 : IF opendialog.Execute()  THEN END;
      | 4 : IF savedialog.Execute()  THEN END;
      | 16: form2.Show;
      | 17: form2.Show;
      | 22: IF printdialog.Execute() THEN END;
      | 24: Close;
      ELSE
      END;
    END TbClick;

  END;

VAR
  form : Form;
  form2: F.Form;

BEGIN
  NEW(form,NIL);
  form.Show;

  NEW(form2,NIL);

  C.Run;
END Project.




