MODULE Extctrls;

IMPORT
  SYSTEM, Trace, W := Windows, Cl := Classes, C := Controls, G := Graphics;

CONST
  tbsButton*   = 1;
  tbsSeparator*= 2;

  tbColor*     = TRUE;
  tbGray*      = FALSE;

TYPE
  Char         = W.Char;
  Boolean      = W.Boolean;
  Shortint     = W.Shortint;
  Integer      = W.Integer;
  Longint      = W.Longint;
  Real         = W.Real;
  Longreal     = W.Longreal;
  Pointer      = W.Pointer;
  Set	       = W.Set;
  String       = W.String;
  Name         = W.Name;

  Panel* = POINTER TO RECORD (C.Control)

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      classname    := "Panel";
      width        := 150;
      height       := 250;
      color        := G.clBtnFace;
    END Create;

    PROCEDURE CreateParams*;
    BEGIN
      CreateParams^;
      style     := style - W.WS_BORDER;
    END CreateParams;

    PROCEDURE WMPaint*(VAR message: C.Message);
    VAR
      dc    : W.HDC;
      size  : W.Size;
    BEGIN
      dc := W.GetDC(handle);
      W.SetBkMode(dc,W.TRANSPARENT);
      W.SetTextColor(dc,font.color);
      W.SelectObject(dc, font.handle);
      W.GetTextExtentPoint32(dc,SYSTEM.ADR(caption),Cl.Length(caption),size);
      W.ExtTextOut(dc,(width - size.cx) DIV 2, (height - size.cy) DIV 2, W.ETO_CLIPPED, NIL, SYSTEM.ADR(caption),Cl.Length(caption), NIL);
      G.Frame3D(dc,0,0,width-1,height-1,G.clWhite,G.clGray);
      W.ReleaseDC(handle,dc);
    END WMPaint;

    PROCEDURE WMEraseBkgnd*(VAR message: C.Message);
    BEGIN
      message.result := 0;
    END WMEraseBkgnd;

  END;

  Toolbutton* = POINTER TO RECORD (C.Control)

    btnstyle*  : Shortint;
    imageindex*: Longint;

    sepwidth   : Longint;
    leavecolor : Longint;
    entercolor : Longint;
    downcolor  : Longint;
    colorizecl : Longint;
    offset     : W.Point;

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      width    := 23;
      height   := 22;
      sepwidth := 5;

      classname    := "Toolbutton";
      IF Parent # NIL THEN
        color  := Parent.color;
      END;

      btnstyle   := tbsButton;

      offset.x   := 0;
      offset.y   := 0;

    END Create;

    PROCEDURE CreateParams*;
    BEGIN
      CreateParams^;
      style     := style - W.WS_BORDER;
    END CreateParams;

    PROCEDURE SetRegion;
    VAR
      reg1,reg2: W.HRgn;
    BEGIN
      reg1 := W.CreateRectRgn(0,0,width,height);
      IF reg1 # 0 THEN
        reg2 := W.CreateRoundRectRgn(0,0,width+1,height+1,2,2);
        IF reg2 # 0 THEN
          W.CombineRgn(reg1,reg1,reg2,W.RGN_AND);
          W.DeleteObject(reg2);
        END;
        W.SetWindowRgn(handle,reg1,W.True);
        W.DeleteObject(reg1);
      END;
    END SetRegion;

    PROCEDURE WMShow*;
    BEGIN
      WMShow^;
      IF btnstyle = tbsButton THEN
        SetRegion;
      ELSIF btnstyle = tbsSeparator THEN
        IF width # sepwidth THEN
          width := sepwidth;
          W.MoveWindow(handle,left,top,width,height,0);
        END;
      END;
    END WMShow;

    PROCEDURE WMEnable*;
    BEGIN
      WMEnable^;
      IF btnstyle = tbsButton THEN
        color  := leavecolor;
      END;
    END WMEnable;

    PROCEDURE WMMouseLeave*;
    BEGIN
      WMMouseLeave^;
      IF btnstyle = tbsButton THEN
        color  := leavecolor;
      END;
    END WMMouseLeave;

    PROCEDURE WMMouseEnter*;
    BEGIN
      WMMouseEnter^;
      IF btnstyle = tbsButton THEN
        color  := entercolor;
      END;
    END WMMouseEnter;

    PROCEDURE WMMouseDown*(VAR message: C.Message);
    BEGIN
      WMMouseDown^(message);
      IF btnstyle = tbsButton THEN
        color  := downcolor;
        offset.x    := 1;
        offset.y    := 1;
      END;
    END WMMouseDown;

    PROCEDURE WMMouseUp*(VAR message: C.Message);
    BEGIN
      WMMouseUp^(message);
      IF (btnstyle = tbsButton) THEN
        color  := entercolor;
        offset.x    := 0;
        offset.y    := 0;
      END;
    END WMMouseUp;

    PROCEDURE WMPaint*(VAR message: C.Message);
    VAR
      pen   : W.HPen;
      dc    : W.HDC;
      parent: Toolbar;
    BEGIN
      dc := W.GetDC(handle);
      IF btnstyle = tbsButton THEN
        parent := owner(Toolbar);
        IF (parent # NIL) & (parent.imagelist # NIL) & (parent.imagelist.count > 0) THEN
          IF (imageindex >= 0) & (imageindex < parent.imagelist.count) THEN
            IF ~ enabled THEN
              color  := parent.color;
              parent.imagelist.Draw(dc,(width - parent.imagelist.width) DIV 2 + offset.x + 1,(height - parent.imagelist.height) DIV 2 + offset.y,imageindex,color,colorizecl,TRUE);
            ELSE
              parent.imagelist.Draw(dc,(width - parent.imagelist.width) DIV 2 + offset.x + 1,(height - parent.imagelist.height) DIV 2 + offset.y,imageindex,color,0,FALSE);
            END;
          END;
        END;
      ELSE
        pen := W.CreatePen(W.PS_SOLID,1,entercolor);
        W.SelectObject(dc, pen);
        W.MoveToEx(dc,width DIV 2,2,NIL);
        W.LineTo(dc,width DIV 2,height-2);
        W.DeleteObject(pen);
      END;
      W.ReleaseDC(handle,dc);
    END WMPaint;

  END;

  Toolbar* = POINTER TO RECORD (C.Control)
    imagelist*   : G.Imagelist;

    leavecolor*  : Longint;
    entercolor*  : Longint;
    downcolor*   : Longint;
    colorizecl*  : Longint;

    btnleft      : Longint;

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      classname    := "Toolbar";
      caption      := "";
      align        := C.alTop;
      height       := 26;
      btnleft      := 2;

      leavecolor   := 0E8E8E8H;
      entercolor   := 0D2D2D2H;
      downcolor    := 0DDDDDDH;
      colorizecl   := 0404040H;

    END Create;

    PROCEDURE CreateParams*;
    BEGIN
      CreateParams^;
      style   := style - W.WS_BORDER;
    END CreateParams;

    PROCEDURE AddButton*(name: String; btnstyle: Shortint): Toolbutton;
    VAR
      btn: Toolbutton;
    BEGIN
      NEW(btn,SELF);
      btn.top := (height - btn.height) DIV 2;
      btn.left := btnleft;
      btn.btnstyle := btnstyle;

      btn.leavecolor := leavecolor;
      btn.entercolor := entercolor;
      btn.downcolor  := downcolor;
      btn.colorizecl := colorizecl;

      IF btnstyle = tbsSeparator THEN
        btn.width := btn.sepwidth;
      END;
      btnleft  := btnleft + btn.width + 1;
      RETURN btn;
    END AddButton;

    PROCEDURE WMSize*(VAR message: C.Message);
    VAR
      i: Longint;
    BEGIN
      WMSize^(message);
      IF controls # NIL THEN
        FOR i := 0 TO controls.count - 1 DO
          IF controls.list[i](C.Control).visible & (controls.list[i](C.Control).left + controls.list[i](C.Control).width > width) THEN
            controls.list[i](C.Control).visible := FALSE;
          ELSIF ~ controls.list[i](C.Control).visible & (controls.list[i](C.Control).left + controls.list[i](C.Control).width <= width) THEN
            controls.list[i](C.Control).visible := TRUE;
          END;
        END;
      END;
    END WMSize;

  END;

  Tabsheet* = POINTER TO RECORD (C.Control)

    tabbutton: Tabbutton;

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      classname    := "Tabsheet";
      left         := 0;
      top          := 0;
      width        := 100;
      height       := 25;
    END Create;

    PROCEDURE CreateParams*;
    BEGIN
      CreateParams^;
      style     := style - W.WS_BORDER;
    END CreateParams;

    PROCEDURE WMPaint*(VAR message: C.Message);
    VAR
      dc    : W.HDC;
      pen   : W.HPen;
    BEGIN
      dc := W.GetDC(handle);
      DrawCaption(dc);

      pen := W.CreatePen(W.PS_SOLID,1,tabbutton.framecolor);
      W.SelectObject(dc,pen);
      G.Rectangle(dc,0,0,width-1,height-1);
      W.SelectObject(dc,pen);

      pen := W.CreatePen(W.PS_SOLID,1,tabbutton.downcolor);
      W.SelectObject(dc,pen);
      W.MoveToEx(dc,tabbutton.left,0,NIL);
      W.LineTo(dc,tabbutton.left+tabbutton.width,0);
      W.DeleteObject(pen);

      W.ReleaseDC(handle,dc);
    END WMPaint;

  END;

  Tabbutton* = POINTER TO RECORD (C.Control)

    tabsheet      : Tabsheet;
    leavecolor*   : Longint;
    entercolor*   : Longint;
    downcolor*    : Longint;
    framecolor*   : Longint;
    activecolor*  : Longint;
    noactivecolor*: Longint;
    radius        : Longint;

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      classname    := "Tabbutton";
      left         := 0;
      top          := 0;
      width        := 100;
      height       := 25;
      color        := 0E8E8E8H;
      leavecolor   := 0E8E8E8H;
      entercolor   := 0D2D2D2H;
      downcolor    := 0FFFFFFH;
      framecolor   := 0777777H;
      activecolor  := 0777777H;
      noactivecolor:= 0AAAAAAH;
      radius       := 8;
    END Create;

    PROCEDURE CreateParams*;
    BEGIN
      CreateParams^;
      style     := style - W.WS_BORDER;
    END CreateParams;

    PROCEDURE SetRegion;
    VAR
      reg1,reg2: W.HRgn;
    BEGIN
      reg1 := W.CreateRectRgn(0,0,width,height);
      IF reg1 # 0 THEN
        reg2 := W.CreateRoundRectRgn(0,0,width+1,height+radius+1,radius,radius);
        IF reg2 # 0 THEN
          W.CombineRgn(reg1,reg1,reg2,W.RGN_AND);
          W.DeleteObject(reg2);
        END;
        W.SetWindowRgn(handle,reg1,W.True);
        W.DeleteObject(reg1);
      END;
    END SetRegion;

    PROCEDURE WMShow*;
    BEGIN
      WMShow^;
      SetRegion;
    END WMShow;

    PROCEDURE WMMouseLeave*;
    BEGIN
      WMMouseLeave^;
      IF (owner # NIL) & (SELF # owner(Pagecontrol).active) THEN
        color  := leavecolor;
      END;
    END WMMouseLeave;

    PROCEDURE WMMouseEnter*;
    BEGIN
      WMMouseEnter^;
      IF (owner # NIL) & (SELF # owner(Pagecontrol).active) THEN
        color  := entercolor;
      END;
    END WMMouseEnter;

    PROCEDURE WMMouseDown*(VAR message: C.Message);
    BEGIN
      WMMouseDown^(message);
      color  := downcolor;
      tabsheet.color := downcolor;
      IF owner # NIL THEN
        owner(Pagecontrol).active := SELF;
        owner(Pagecontrol).UpdatePages;
      END;
    END WMMouseDown;

    PROCEDURE WMPaint*(VAR message: C.Message);
    VAR
      dc    : W.HDC;
    BEGIN
      dc := W.GetDC(handle);
      DrawCaption(dc);
      IF (owner # NIL) & (SELF = owner(Pagecontrol).active) THEN
        framecolor := activecolor;
      ELSE
        framecolor := noactivecolor;
      END;
      G.RoundRect(dc,0,0,width-1,height+radius,framecolor,radius,radius);
      W.ReleaseDC(handle,dc);
    END WMPaint;

  END;

  Pagecontrol* = POINTER TO RECORD (C.Control)

    btnleft : Longint;
    active* : Tabbutton;

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      classname    := "Pagecontrol";
      width        := 250;
      height       := 250;
      btnleft      := 5;
    END Create;

    PROCEDURE CreateParams*;
    BEGIN
      CreateParams^;
      style     := style - W.WS_BORDER;
    END CreateParams;

    PROCEDURE UpdatePages*;
    VAR
      i: Longint;
    BEGIN
      IF controls # NIL THEN
        FOR i := 0 TO controls.count - 1 DO
          IF controls.list[i] IS Tabbutton THEN
            IF controls.list[i](Tabbutton) # active THEN
              IF controls.list[i](Tabbutton).tabsheet.visible THEN
                controls.list[i](Tabbutton).tabsheet.visible := FALSE;
              END;
              controls.list[i](Tabbutton).color := controls.list[i](Tabbutton).leavecolor;
            END;
          END;
        END;
        IF ~ active.tabsheet.visible THEN
          active.tabsheet.visible := TRUE;
        ELSE
          active.color  := active.downcolor;
          active.tabsheet.color := active.downcolor;
        END;
      END;
    END UpdatePages;

    PROCEDURE NewPage*(caption: String);
    VAR
      tab: Tabbutton;
    BEGIN
      NEW(tab,SELF);
      tab.left := btnleft;
      btnleft := btnleft + tab.width;
      IF caption # "" THEN
        COPY(caption,tab.caption);
      END;
      NEW(tab.tabsheet,SELF);
      tab.tabsheet.left := 0;
      tab.tabsheet.color := tab.color;
      tab.tabsheet.top  := tab.height;
      tab.tabsheet.width := width;
      tab.tabsheet.height := height - tab.tabsheet.top;
      tab.tabsheet.tabbutton := tab;
      active := tab;
      UpdatePages;
    END NewPage;

    PROCEDURE WMSize*(VAR message: C.Message);
    VAR
      i: Longint;
    BEGIN
      WMSize^(message);
      IF controls # NIL THEN
        FOR i := 0 TO controls.count - 1 DO
          IF controls.list[i] IS Tabbutton THEN
            controls.list[i](Tabbutton).tabsheet.left := 0;
            controls.list[i](Tabbutton).tabsheet.top := controls.list[i](Tabbutton).height;
            controls.list[i](Tabbutton).tabsheet.width := width;
            controls.list[i](Tabbutton).tabsheet.height := height - controls.list[i](Tabbutton).tabsheet.top;
          END;
        END;
      END;
    END WMSize;

    PROCEDURE WMPaint*(VAR message: C.Message);
    BEGIN
    END WMPaint;

  END;

END Extctrls.

